##// END OF EJS Templates
.
burnbabyburn -
r314:0bf152b27784
parent child
Show More
@@ -1,790 +1,768
1 #!/bin/bash
1 #!/bin/bash
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 #Kernel Branch
48 #Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
55 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
56 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57
57
58 # Firmware directory: Blank if download from github
58 # Firmware directory: Blank if download from github
59 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
59 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
60
60
61 # Build directories
61 # Build directories
62 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
63 BUILDDIR="${BASEDIR}/build"
63 BUILDDIR="${BASEDIR}/build"
64
64
65 # Prepare date string for default image file name
65 # Prepare date string for default image file name
66 DATE="$(date +%Y-%m-%d)"
66 DATE="$(date +%Y-%m-%d)"
67 if [ -z "$KERNEL_BRANCH" ] ; then
67 if [ -z "$KERNEL_BRANCH" ] ; then
68 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 else
69 else
70 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
71 fi
71 fi
72
72
73 # Chroot directories
73 # Chroot directories
74 R="${BUILDDIR}/chroot"
74 R="${BUILDDIR}/chroot"
75 ETC_DIR="${R}/etc"
75 ETC_DIR="${R}/etc"
76 LIB_DIR="${R}/lib"
76 LIB_DIR="${R}/lib"
77 BOOT_DIR="${R}/boot/firmware"
77 BOOT_DIR="${R}/boot/firmware"
78 KERNEL_DIR="${R}/usr/src/linux"
78 KERNEL_DIR="${R}/usr/src/linux"
79 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
80
80
81 # General settings
81 # General settings
82 SET_ARCH=${SET_ARCH:=32}
82 SET_ARCH=${SET_ARCH:=32}
83 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
83 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
84 PASSWORD=${PASSWORD:=raspberry}
84 PASSWORD=${PASSWORD:=raspberry}
85 USER_PASSWORD=${USER_PASSWORD:=raspberry}
85 USER_PASSWORD=${USER_PASSWORD:=raspberry}
86 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
86 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
87 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
87 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
88 EXPANDROOT=${EXPANDROOT:=true}
88 EXPANDROOT=${EXPANDROOT:=true}
89
89
90 # Keyboard settings
90 # Keyboard settings
91 XKB_MODEL=${XKB_MODEL:=""}
91 XKB_MODEL=${XKB_MODEL:=""}
92 XKB_LAYOUT=${XKB_LAYOUT:=""}
92 XKB_LAYOUT=${XKB_LAYOUT:=""}
93 XKB_VARIANT=${XKB_VARIANT:=""}
93 XKB_VARIANT=${XKB_VARIANT:=""}
94 XKB_OPTIONS=${XKB_OPTIONS:=""}
94 XKB_OPTIONS=${XKB_OPTIONS:=""}
95
95
96 # Network settings (DHCP)
96 # Network settings (DHCP)
97 ENABLE_DHCP=${ENABLE_DHCP:=true}
97 ENABLE_DHCP=${ENABLE_DHCP:=true}
98
98
99 # Network settings (static)
99 # Network settings (static)
100 NET_ADDRESS=${NET_ADDRESS:=""}
100 NET_ADDRESS=${NET_ADDRESS:=""}
101 NET_GATEWAY=${NET_GATEWAY:=""}
101 NET_GATEWAY=${NET_GATEWAY:=""}
102 NET_DNS_1=${NET_DNS_1:=""}
102 NET_DNS_1=${NET_DNS_1:=""}
103 NET_DNS_2=${NET_DNS_2:=""}
103 NET_DNS_2=${NET_DNS_2:=""}
104 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
104 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
105 NET_NTP_1=${NET_NTP_1:=""}
105 NET_NTP_1=${NET_NTP_1:=""}
106 NET_NTP_2=${NET_NTP_2:=""}
106 NET_NTP_2=${NET_NTP_2:=""}
107
107
108 # APT settings
108 # APT settings
109 APT_PROXY=${APT_PROXY:=""}
109 APT_PROXY=${APT_PROXY:=""}
110 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
110 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
111
111
112 # Feature settings
112 # Feature settings
113 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
113 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
114 ENABLE_I2C=${ENABLE_I2C:=false}
114 ENABLE_I2C=${ENABLE_I2C:=false}
115 ENABLE_SPI=${ENABLE_SPI:=false}
115 ENABLE_SPI=${ENABLE_SPI:=false}
116 ENABLE_IPV6=${ENABLE_IPV6:=true}
116 ENABLE_IPV6=${ENABLE_IPV6:=true}
117 ENABLE_SSHD=${ENABLE_SSHD:=true}
117 ENABLE_SSHD=${ENABLE_SSHD:=true}
118 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
118 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
119 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
119 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
120 ENABLE_SOUND=${ENABLE_SOUND:=true}
120 ENABLE_SOUND=${ENABLE_SOUND:=true}
121 ENABLE_DBUS=${ENABLE_DBUS:=true}
121 ENABLE_DBUS=${ENABLE_DBUS:=true}
122 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
122 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
123 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
123 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
124 ENABLE_XORG=${ENABLE_XORG:=false}
124 ENABLE_XORG=${ENABLE_XORG:=false}
125 ENABLE_WM=${ENABLE_WM:=""}
125 ENABLE_WM=${ENABLE_WM:=""}
126 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
126 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
127 ENABLE_USER=${ENABLE_USER:=true}
127 ENABLE_USER=${ENABLE_USER:=true}
128 USER_NAME=${USER_NAME:="pi"}
128 USER_NAME=${USER_NAME:="pi"}
129 ENABLE_ROOT=${ENABLE_ROOT:=false}
129 ENABLE_ROOT=${ENABLE_ROOT:=false}
130 ENABLE_QEMU=${ENABLE_QEMU:=false}
130 ENABLE_QEMU=${ENABLE_QEMU:=false}
131
131
132 # SSH settings
132 # SSH settings
133 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
133 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
134 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
134 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
135 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
135 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
136 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
136 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
137 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
137 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
138
138
139 # Advanced settings
139 # Advanced settings
140 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
140 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
141 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
141 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
142 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
142 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
143 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
143 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
144 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
144 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
145 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
145 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
146 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
146 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
147 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
147 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
148 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
148 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
149 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
149 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
150 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
150 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
151 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
151 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
152
152
153 # Kernel compilation settings
153 # Kernel compilation settings
154 BUILD_KERNEL=${BUILD_KERNEL:=true}
154 BUILD_KERNEL=${BUILD_KERNEL:=true}
155 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
155 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
156 KERNEL_THREADS=${KERNEL_THREADS:=1}
156 KERNEL_THREADS=${KERNEL_THREADS:=1}
157 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
157 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
158 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
158 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
159 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
159 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
160 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
160 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
161 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
161 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
162
162
163 # Kernel compilation from source directory settings
163 # Kernel compilation from source directory settings
164 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
164 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
165 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
165 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
166 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
166 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
167 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
167 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
168
168
169 # Reduce disk usage settings
169 # Reduce disk usage settings
170 REDUCE_APT=${REDUCE_APT:=true}
170 REDUCE_APT=${REDUCE_APT:=true}
171 REDUCE_DOC=${REDUCE_DOC:=true}
171 REDUCE_DOC=${REDUCE_DOC:=true}
172 REDUCE_MAN=${REDUCE_MAN:=true}
172 REDUCE_MAN=${REDUCE_MAN:=true}
173 REDUCE_VIM=${REDUCE_VIM:=false}
173 REDUCE_VIM=${REDUCE_VIM:=false}
174 REDUCE_BASH=${REDUCE_BASH:=false}
174 REDUCE_BASH=${REDUCE_BASH:=false}
175 REDUCE_HWDB=${REDUCE_HWDB:=true}
175 REDUCE_HWDB=${REDUCE_HWDB:=true}
176 REDUCE_SSHD=${REDUCE_SSHD:=true}
176 REDUCE_SSHD=${REDUCE_SSHD:=true}
177 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
177 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
178
178
179 # Encrypted filesystem settings
179 # Encrypted filesystem settings
180 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
180 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
181 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
181 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
182 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
182 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
183 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
183 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
184 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
184 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
185
185
186 # Chroot scripts directory
186 # Chroot scripts directory
187 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
187 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
188
188
189 # Packages required in the chroot build environment
189 # Packages required in the chroot build environment
190 APT_INCLUDES=${APT_INCLUDES:=""}
190 APT_INCLUDES=${APT_INCLUDES:=""}
191 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
191 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
192
192
193 # Packages required for bootstrapping
193 # Packages required for bootstrapping
194 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
194 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
195 MISSING_PACKAGES=""
195 MISSING_PACKAGES=""
196
196
197 #autoselect best apt mirror
197 #autoselect best apt mirror
198 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} netselect-apt"
198 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} netselect-apt"
199
199
200 # Packages installed for c/c++ build environment in chroot (keep empty)
200 # Packages installed for c/c++ build environment in chroot (keep empty)
201 COMPILER_PACKAGES=""
201 COMPILER_PACKAGES=""
202
202
203 set +x
203 set +x
204
204
205 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
206 if [ -n "$SET_ARCH" ] ; then
206 if [ -n "$SET_ARCH" ] ; then
207 echo "Setting Architecture specific settings"
207 echo "Setting Architecture specific settings"
208 ##################################
208 ##################################
209 # 64 bit config
209 # 64 bit config
210 ##################################
210 ##################################
211 if [ "$SET_ARCH" = 64 ] ; then
211 if [ "$SET_ARCH" = 64 ] ; then
212 echo "64 bit mode selected - Setting up enviroment"
212 echo "64 bit mode selected - Setting up enviroment"
213 # 64 bit depended settings
213 # 64 bit depended settings
214 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
215 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
216 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
217 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
218 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
219 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
220
220
221 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
221 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
222 # RPI 3 serie specific settings
222 # RPI 3 serie specific settings
223 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
223 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
224 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
224 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
225
225
226 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
226 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
227 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
227 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
228 else
228 else
229 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
229 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
230 exit 1
230 exit 1
231 fi
231 fi
232 fi
232 fi
233
233
234 ##################################
234 ##################################
235 # 32 bit config
235 # 32 bit config
236 ##################################
236 ##################################
237 if [ "$SET_ARCH" = 32 ] ; then
237 if [ "$SET_ARCH" = 32 ] ; then
238 echo "32 bit mode selected - Setting up enviroment"
238 echo "32 bit mode selected - Setting up enviroment"
239 #General 32bit configuration
239 #General 32bit configuration
240 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
240 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
241 KERNEL_ARCH=${KERNEL_ARCH:=arm}
241 KERNEL_ARCH=${KERNEL_ARCH:=arm}
242 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
242 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
243
243
244 #Raspberry setting grouped by board compability
244 #Raspberry setting grouped by board compability
245 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
245 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
246 echo "Setting settings for bcm2835 Raspberry PI boards"
246 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
247 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
247 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
248 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
248 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
249 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
249 RELEASE_ARCH=${RELEASE_ARCH:=armel}
250 RELEASE_ARCH=${RELEASE_ARCH:=armel}
250 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
251 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
251 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
252 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
252 fi
253 fi
253 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
254 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
255 echo "Setting settings for bcm2837 Raspberry PI boards"
254 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
255 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
256 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
258 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
257 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
259 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
258 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
260 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
259 fi
261 fi
262
263 echo "Setting Raspberry PI $RPI_MODEL specific configuration"
264
260 #Device specific configuration
265 #Device specific configuration
261 case "$RPI_MODEL" in
266 case "$RPI_MODEL" in
262 0)
267 0)
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
268 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
264 ;;
269 ;;
265 1)
270 1)
266 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
271 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
267 ;;
272 ;;
268 1P)
273 1P)
269 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
274 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
270 ;;
275 ;;
271 2)
276 2)
272 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
277 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
273 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
278 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
274 ;;
279 ;;
275 3)
280 3)
276 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
281 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
277 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
282 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
278 ;;
283 ;;
279 3P)
284 3P)
280 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
285 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
281 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
286 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
282 ;;
287 ;;
283 *)
288 *)
284 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
289 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
285 exit 1
290 exit 1
286 ;;
291 ;;
287 esac
292 esac
288
293
289 #Device specific configuration
290 # if [ "$RPI_MODEL" = 0 ] ; then
291 # DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
292 # fi
293 # if [ "$RPI_MODEL" = 1 ] ; then
294 # DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
295 # fi
296 # if [ "$RPI_MODEL" = 1P ] ; then
297 # DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
298 # fi
299 # if [ "$RPI_MODEL" = 2 ] ; then
300 # DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
301 # UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
302 # #Precompiled Kernel rpi2
303 # #COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
304 # fi
305 # if [ "$RPI_MODEL" = 3 ] ; then
306 # DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
307 # UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
308 # fi
309 # if [ "$RPI_MODEL" = 3P ] ; then
310 # DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
311 # UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
312 # fi
313 # if [ -z "$RPI_MODEL" ] ; then
314 # echo "error: Raspberry Pi model $RPI_MODEL is not set!"
315 # exit 1
316 # fi
317
318 #end 32 bit
294 #end 32 bit
319 fi
295 fi
320 #SET_ARCH not set
296 #SET_ARCH not set
321 else
297 else
322 echo "error: Please set '32' or '64' as value for SET_ARCH"
298 echo "error: Please set '32' or '64' as value for SET_ARCH"
323 exit 1
299 exit 1
324 fi
300 fi
325
301
326 # Check if the internal wireless interface is supported by the RPi model
302 # Check if the internal wireless interface is supported by the RPi model
327 if [ "$ENABLE_WIRELESS" = true ] && { [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; } ; then
303 if [ "$ENABLE_WIRELESS" = true ] ; then
304 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
328 echo "error: The selected Raspberry Pi model has no internal wireless interface"
305 echo "error: The selected Raspberry Pi model has no internal wireless interface"
329 exit 1
306 exit 1
330 else
307 else
331 echo "Raspberry Pi model"
308 echo "Raspberry Pi model"
332 fi
309 fi
310 fi
333
311
334 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
312 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
335 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
313 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
336 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
314 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
337 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
315 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
338 exit 1
316 exit 1
339 fi
317 fi
340 fi
318 fi
341
319
342 # Add libncurses5 to enable kernel menuconfig
320 # Add libncurses5 to enable kernel menuconfig
343 if [ "$KERNEL_MENUCONFIG" = true ] ; then
321 if [ "$KERNEL_MENUCONFIG" = true ] ; then
344 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
345 fi
323 fi
346
324
347 # Add ccache compiler cache for (faster) kernel cross (re)compilation
325 # Add ccache compiler cache for (faster) kernel cross (re)compilation
348 if [ "$KERNEL_CCACHE" = true ] ; then
326 if [ "$KERNEL_CCACHE" = true ] ; then
349 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
327 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
350 fi
328 fi
351
329
352 # Add cryptsetup package to enable filesystem encryption
330 # Add cryptsetup package to enable filesystem encryption
353 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
331 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
354 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
332 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
355 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
333 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
356
334
357 if [ -z "$CRYPTFS_PASSWORD" ] ; then
335 if [ -z "$CRYPTFS_PASSWORD" ] ; then
358 echo "error: no password defined (CRYPTFS_PASSWORD)!"
336 echo "error: no password defined (CRYPTFS_PASSWORD)!"
359 exit 1
337 exit 1
360 fi
338 fi
361 ENABLE_INITRAMFS=true
339 ENABLE_INITRAMFS=true
362 fi
340 fi
363
341
364 # Add initramfs generation tools
342 # Add initramfs generation tools
365 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
343 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
366 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
344 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
367 fi
345 fi
368
346
369 # Add device-tree-compiler required for building the U-Boot bootloader
347 # Add device-tree-compiler required for building the U-Boot bootloader
370 if [ "$ENABLE_UBOOT" = true ] ; then
348 if [ "$ENABLE_UBOOT" = true ] ; then
371 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
349 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
372 fi
350 fi
373
351
374 # Check if root SSH (v2) public key file exists
352 # Check if root SSH (v2) public key file exists
375 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
353 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
376 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
354 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
377 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
355 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
378 exit 1
356 exit 1
379 fi
357 fi
380 fi
358 fi
381
359
382 # Check if $USER_NAME SSH (v2) public key file exists
360 # Check if $USER_NAME SSH (v2) public key file exists
383 if [ -n "$SSH_USER_PUB_KEY" ] ; then
361 if [ -n "$SSH_USER_PUB_KEY" ] ; then
384 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
362 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
385 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
363 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
386 exit 1
364 exit 1
387 fi
365 fi
388 fi
366 fi
389
367
390 # Check if all required packages are installed on the build system
368 # Check if all required packages are installed on the build system
391 for package in $REQUIRED_PACKAGES ; do
369 for package in $REQUIRED_PACKAGES ; do
392 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
370 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
393 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
371 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
394 fi
372 fi
395 done
373 done
396
374
397 # If there are missing packages ask confirmation for install, or exit
375 # If there are missing packages ask confirmation for install, or exit
398 if [ -n "$MISSING_PACKAGES" ] ; then
376 if [ -n "$MISSING_PACKAGES" ] ; then
399 echo "the following packages needed by this script are not installed:"
377 echo "the following packages needed by this script are not installed:"
400 echo "$MISSING_PACKAGES"
378 echo "$MISSING_PACKAGES"
401
379
402 printf "\ndo you want to install the missing packages right now? [y/n] "
380 printf "\ndo you want to install the missing packages right now? [y/n] "
403 read -r confirm
381 read -r confirm
404 [ "$confirm" != "y" ] && exit 1
382 [ "$confirm" != "y" ] && exit 1
405
383
406 # Make sure all missing required packages are installed
384 # Make sure all missing required packages are installed
407 apt-get -qq -y install "${MISSING_PACKAGES}"
385 apt-get -qq -y install "${MISSING_PACKAGES}"
408 fi
386 fi
409
387
410 # Check if ./bootstrap.d directory exists
388 # Check if ./bootstrap.d directory exists
411 if [ ! -d "./bootstrap.d/" ] ; then
389 if [ ! -d "./bootstrap.d/" ] ; then
412 echo "error: './bootstrap.d' required directory not found!"
390 echo "error: './bootstrap.d' required directory not found!"
413 exit 1
391 exit 1
414 fi
392 fi
415
393
416 # Check if ./files directory exists
394 # Check if ./files directory exists
417 if [ ! -d "./files/" ] ; then
395 if [ ! -d "./files/" ] ; then
418 echo "error: './files' required directory not found!"
396 echo "error: './files' required directory not found!"
419 exit 1
397 exit 1
420 fi
398 fi
421
399
422 # Check if specified KERNELSRC_DIR directory exists
400 # Check if specified KERNELSRC_DIR directory exists
423 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
401 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
424 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
402 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
425 exit 1
403 exit 1
426 fi
404 fi
427
405
428 # Check if specified UBOOTSRC_DIR directory exists
406 # Check if specified UBOOTSRC_DIR directory exists
429 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
407 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
430 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
408 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
431 exit 1
409 exit 1
432 fi
410 fi
433
411
434 # Check if specified FBTURBOSRC_DIR directory exists
412 # Check if specified FBTURBOSRC_DIR directory exists
435 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
413 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
436 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
414 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
437 exit 1
415 exit 1
438 fi
416 fi
439
417
440 # Check if specified CHROOT_SCRIPTS directory exists
418 # Check if specified CHROOT_SCRIPTS directory exists
441 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
419 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
442 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
420 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
443 exit 1
421 exit 1
444 fi
422 fi
445
423
446 # Check if specified device mapping already exists (will be used by cryptsetup)
424 # Check if specified device mapping already exists (will be used by cryptsetup)
447 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
425 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
448 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
426 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
449 exit 1
427 exit 1
450 fi
428 fi
451
429
452 # Don't clobber an old build
430 # Don't clobber an old build
453 if [ -e "$BUILDDIR" ] ; then
431 if [ -e "$BUILDDIR" ] ; then
454 echo "error: directory ${BUILDDIR} already exists, not proceeding"
432 echo "error: directory ${BUILDDIR} already exists, not proceeding"
455 exit 1
433 exit 1
456 fi
434 fi
457
435
458 # Setup chroot directory
436 # Setup chroot directory
459 mkdir -p "${R}"
437 mkdir -p "${R}"
460
438
461 # Check if build directory has enough of free disk space >512MB
439 # Check if build directory has enough of free disk space >512MB
462 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
440 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
463 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
441 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
464 exit 1
442 exit 1
465 fi
443 fi
466
444
467 set -x
445 set -x
468
446
469 # Call "cleanup" function on various signals and errors
447 # Call "cleanup" function on various signals and errors
470 trap cleanup 0 1 2 3 6
448 trap cleanup 0 1 2 3 6
471
449
472 # Add required packages for the minbase installation
450 # Add required packages for the minbase installation
473 if [ "$ENABLE_MINBASE" = true ] ; then
451 if [ "$ENABLE_MINBASE" = true ] ; then
474 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
452 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
475 fi
453 fi
476
454
477 # Add required locales packages
455 # Add required locales packages
478 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || { [ -n "$XKB_MODEL" ] || [ -n "$XKB_LAYOUT" ] || [ -n "$XKB_VARIANT" ] || [ -n "$XKB_OPTIONS" ] ; } ; then
456 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || { [ -n "$XKB_MODEL" ] || [ -n "$XKB_LAYOUT" ] || [ -n "$XKB_VARIANT" ] || [ -n "$XKB_OPTIONS" ] ; } ; then
479 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
457 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
480 fi
458 fi
481
459
482 # Add parted package, required to get partprobe utility
460 # Add parted package, required to get partprobe utility
483 if [ "$EXPANDROOT" = true ] ; then
461 if [ "$EXPANDROOT" = true ] ; then
484 APT_INCLUDES="${APT_INCLUDES},parted"
462 APT_INCLUDES="${APT_INCLUDES},parted"
485 fi
463 fi
486
464
487 # Add dbus package, recommended if using systemd
465 # Add dbus package, recommended if using systemd
488 if [ "$ENABLE_DBUS" = true ] ; then
466 if [ "$ENABLE_DBUS" = true ] ; then
489 APT_INCLUDES="${APT_INCLUDES},dbus"
467 APT_INCLUDES="${APT_INCLUDES},dbus"
490 fi
468 fi
491
469
492 # Add iptables IPv4/IPv6 package
470 # Add iptables IPv4/IPv6 package
493 if [ "$ENABLE_IPTABLES" = true ] ; then
471 if [ "$ENABLE_IPTABLES" = true ] ; then
494 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
472 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
495 fi
473 fi
496
474
497 # Add openssh server package
475 # Add openssh server package
498 if [ "$ENABLE_SSHD" = true ] ; then
476 if [ "$ENABLE_SSHD" = true ] ; then
499 APT_INCLUDES="${APT_INCLUDES},openssh-server"
477 APT_INCLUDES="${APT_INCLUDES},openssh-server"
500 fi
478 fi
501
479
502 # Add alsa-utils package
480 # Add alsa-utils package
503 if [ "$ENABLE_SOUND" = true ] ; then
481 if [ "$ENABLE_SOUND" = true ] ; then
504 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
482 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
505 fi
483 fi
506
484
507 # Add rng-tools package
485 # Add rng-tools package
508 if [ "$ENABLE_HWRANDOM" = true ] ; then
486 if [ "$ENABLE_HWRANDOM" = true ] ; then
509 APT_INCLUDES="${APT_INCLUDES},rng-tools"
487 APT_INCLUDES="${APT_INCLUDES},rng-tools"
510 fi
488 fi
511
489
512 # Add fbturbo video driver
490 # Add fbturbo video driver
513 if [ "$ENABLE_FBTURBO" = true ] ; then
491 if [ "$ENABLE_FBTURBO" = true ] ; then
514 # Enable xorg package dependencies
492 # Enable xorg package dependencies
515 ENABLE_XORG=true
493 ENABLE_XORG=true
516 fi
494 fi
517
495
518 # Add user defined window manager package
496 # Add user defined window manager package
519 if [ -n "$ENABLE_WM" ] ; then
497 if [ -n "$ENABLE_WM" ] ; then
520 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
498 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
521
499
522 # Enable xorg package dependencies
500 # Enable xorg package dependencies
523 ENABLE_XORG=true
501 ENABLE_XORG=true
524 fi
502 fi
525
503
526 # Add xorg package
504 # Add xorg package
527 if [ "$ENABLE_XORG" = true ] ; then
505 if [ "$ENABLE_XORG" = true ] ; then
528 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
506 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
529 fi
507 fi
530
508
531 # Replace selected packages with smaller clones
509 # Replace selected packages with smaller clones
532 if [ "$ENABLE_REDUCE" = true ] ; then
510 if [ "$ENABLE_REDUCE" = true ] ; then
533 # Add levee package instead of vim-tiny
511 # Add levee package instead of vim-tiny
534 if [ "$REDUCE_VIM" = true ] ; then
512 if [ "$REDUCE_VIM" = true ] ; then
535 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
513 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
536 fi
514 fi
537
515
538 # Add dropbear package instead of openssh-server
516 # Add dropbear package instead of openssh-server
539 if [ "$REDUCE_SSHD" = true ] ; then
517 if [ "$REDUCE_SSHD" = true ] ; then
540 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
518 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
541 fi
519 fi
542 fi
520 fi
543
521
544 # Configure kernel sources if no KERNELSRC_DIR
522 # Configure kernel sources if no KERNELSRC_DIR
545 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
523 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
546 KERNELSRC_CONFIG=true
524 KERNELSRC_CONFIG=true
547 fi
525 fi
548
526
549 # Configure reduced kernel
527 # Configure reduced kernel
550 if [ "$KERNEL_REDUCE" = true ] ; then
528 if [ "$KERNEL_REDUCE" = true ] ; then
551 KERNELSRC_CONFIG=false
529 KERNELSRC_CONFIG=false
552 fi
530 fi
553
531
554 # Execute bootstrap scripts
532 # Execute bootstrap scripts
555 for SCRIPT in bootstrap.d/*.sh; do
533 for SCRIPT in bootstrap.d/*.sh; do
556 head -n 3 "$SCRIPT"
534 head -n 3 "$SCRIPT"
557 . "$SCRIPT"
535 . "$SCRIPT"
558 done
536 done
559
537
560 ## Execute custom bootstrap scripts
538 ## Execute custom bootstrap scripts
561 if [ -d "custom.d" ] ; then
539 if [ -d "custom.d" ] ; then
562 for SCRIPT in custom.d/*.sh; do
540 for SCRIPT in custom.d/*.sh; do
563 . "$SCRIPT"
541 . "$SCRIPT"
564 done
542 done
565 fi
543 fi
566
544
567 # Execute custom scripts inside the chroot
545 # Execute custom scripts inside the chroot
568 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
546 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
569 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
547 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
570 chroot_exec /bin/bash -x <<'EOF'
548 chroot_exec /bin/bash -x <<'EOF'
571 for SCRIPT in /chroot_scripts/* ; do
549 for SCRIPT in /chroot_scripts/* ; do
572 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
550 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
573 $SCRIPT
551 $SCRIPT
574 fi
552 fi
575 done
553 done
576 EOF
554 EOF
577 rm -rf "${R}/chroot_scripts"
555 rm -rf "${R}/chroot_scripts"
578 fi
556 fi
579
557
580 # Remove c/c++ build environment from the chroot
558 # Remove c/c++ build environment from the chroot
581 chroot_remove_cc
559 chroot_remove_cc
582
560
583 # Generate required machine-id
561 # Generate required machine-id
584 MACHINE_ID=$(dbus-uuidgen)
562 MACHINE_ID=$(dbus-uuidgen)
585 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
563 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
586 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
564 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
587
565
588 # APT Cleanup
566 # APT Cleanup
589 chroot_exec apt-get -y clean
567 chroot_exec apt-get -y clean
590 chroot_exec apt-get -y autoclean
568 chroot_exec apt-get -y autoclean
591 chroot_exec apt-get -y autoremove
569 chroot_exec apt-get -y autoremove
592
570
593 # Unmount mounted filesystems
571 # Unmount mounted filesystems
594 umount -l "${R}/proc"
572 umount -l "${R}/proc"
595 umount -l "${R}/sys"
573 umount -l "${R}/sys"
596
574
597 # Clean up directories
575 # Clean up directories
598 rm -rf "${R}/run/*"
576 rm -rf "${R}/run/*"
599 rm -rf "${R}/tmp/*"
577 rm -rf "${R}/tmp/*"
600
578
601 # Clean up files
579 # Clean up files
602 rm -f "${ETC_DIR}/ssh/ssh_host_*"
580 rm -f "${ETC_DIR}/ssh/ssh_host_*"
603 rm -f "${ETC_DIR}/dropbear/dropbear_*"
581 rm -f "${ETC_DIR}/dropbear/dropbear_*"
604 rm -f "${ETC_DIR}/apt/sources.list.save"
582 rm -f "${ETC_DIR}/apt/sources.list.save"
605 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
583 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
606 rm -f "${ETC_DIR}/*-"
584 rm -f "${ETC_DIR}/*-"
607 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
585 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
608 rm -f "${ETC_DIR}/resolv.conf"
586 rm -f "${ETC_DIR}/resolv.conf"
609 rm -f "${R}/root/.bash_history"
587 rm -f "${R}/root/.bash_history"
610 rm -f "${R}/var/lib/urandom/random-seed"
588 rm -f "${R}/var/lib/urandom/random-seed"
611 rm -f "${R}/initrd.img"
589 rm -f "${R}/initrd.img"
612 rm -f "${R}/vmlinuz"
590 rm -f "${R}/vmlinuz"
613 rm -f "${R}${QEMU_BINARY}"
591 rm -f "${R}${QEMU_BINARY}"
614
592
615 if [ "$ENABLE_QEMU" = true ] ; then
593 if [ "$ENABLE_QEMU" = true ] ; then
616 # Configure qemu compatible kernel
594 # Configure qemu compatible kernel
617 DTB_FILE=vexpress-v2p-ca15_a7.dtb
595 DTB_FILE=vexpress-v2p-ca15_a7.dtb
618 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
596 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
619 KERNEL_DEFCONFIG="vexpress_defconfig"
597 KERNEL_DEFCONFIG="vexpress_defconfig"
620 if [ "$KERNEL_MENUCONFIG" = false ] ; then
598 if [ "$KERNEL_MENUCONFIG" = false ] ; then
621 KERNEL_OLDDEFCONFIG=true
599 KERNEL_OLDDEFCONFIG=true
622 fi
600 fi
623
601
624 # Setup QEMU directory
602 # Setup QEMU directory
625 mkdir "${BASEDIR}/qemu"
603 mkdir "${BASEDIR}/qemu"
626
604
627 # Copy kernel image to QEMU directory
605 # Copy kernel image to QEMU directory
628 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
606 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
629
607
630 # Copy kernel config to QEMU directory
608 # Copy kernel config to QEMU directory
631 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
609 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
632
610
633 # Copy kernel dtbs to QEMU directory
611 # Copy kernel dtbs to QEMU directory
634 for dtb in "${BOOT_DIR}/"*.dtb ; do
612 for dtb in "${BOOT_DIR}/"*.dtb ; do
635 if [ -f "${dtb}" ] ; then
613 if [ -f "${dtb}" ] ; then
636 install_readonly "${dtb}" "${BASEDIR}/qemu/"
614 install_readonly "${dtb}" "${BASEDIR}/qemu/"
637 fi
615 fi
638 done
616 done
639
617
640 # Copy kernel overlays to QEMU directory
618 # Copy kernel overlays to QEMU directory
641 if [ -d "${BOOT_DIR}/overlays" ] ; then
619 if [ -d "${BOOT_DIR}/overlays" ] ; then
642 # Setup overlays dtbs directory
620 # Setup overlays dtbs directory
643 mkdir "${BASEDIR}/qemu/overlays"
621 mkdir "${BASEDIR}/qemu/overlays"
644
622
645 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
623 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
646 if [ -f "${dtb}" ] ; then
624 if [ -f "${dtb}" ] ; then
647 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
625 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
648 fi
626 fi
649 done
627 done
650 fi
628 fi
651
629
652 # Copy u-boot files to QEMU directory
630 # Copy u-boot files to QEMU directory
653 if [ "$ENABLE_UBOOT" = true ] ; then
631 if [ "$ENABLE_UBOOT" = true ] ; then
654 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
632 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
655 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
633 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
656 fi
634 fi
657 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
635 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
658 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
636 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
659 fi
637 fi
660 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
638 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
661 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
639 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
662 fi
640 fi
663 fi
641 fi
664
642
665 # Copy initramfs to QEMU directory
643 # Copy initramfs to QEMU directory
666 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
644 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
667 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
645 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
668 fi
646 fi
669 fi
647 fi
670
648
671 # Calculate size of the chroot directory in KB
649 # Calculate size of the chroot directory in KB
672 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
650 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
673
651
674 # Calculate the amount of needed 512 Byte sectors
652 # Calculate the amount of needed 512 Byte sectors
675 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
653 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
676 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
654 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
677 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
655 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
678
656
679 # The root partition is EXT4
657 # The root partition is EXT4
680 # This means more space than the actual used space of the chroot is used.
658 # This means more space than the actual used space of the chroot is used.
681 # As overhead for journaling and reserved blocks 35% are added.
659 # As overhead for journaling and reserved blocks 35% are added.
682 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
660 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
683
661
684 # Calculate required image size in 512 Byte sectors
662 # Calculate required image size in 512 Byte sectors
685 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
663 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
686
664
687 # Prepare image file
665 # Prepare image file
688 if [ "$ENABLE_SPLITFS" = true ] ; then
666 if [ "$ENABLE_SPLITFS" = true ] ; then
689 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
667 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
690 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
691 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
669 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
692 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
693
671
694 # Write firmware/boot partition tables
672 # Write firmware/boot partition tables
695 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
673 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
696 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
674 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
697 EOM
675 EOM
698
676
699 # Write root partition table
677 # Write root partition table
700 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
678 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
701 "${TABLE_SECTORS}","${ROOT_SECTORS}",83
679 "${TABLE_SECTORS}","${ROOT_SECTORS}",83
702 EOM
680 EOM
703
681
704 # Setup temporary loop devices
682 # Setup temporary loop devices
705 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
683 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
706 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
684 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
707 else # ENABLE_SPLITFS=false
685 else # ENABLE_SPLITFS=false
708 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
686 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
709 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
710
688
711 # Write partition table
689 # Write partition table
712 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
690 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
713 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
691 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
714 "${ROOT_OFFSET}","${ROOT_SECTORS}",83
692 "${ROOT_OFFSET}","${ROOT_SECTORS}",83
715 EOM
693 EOM
716
694
717 # Setup temporary loop devices
695 # Setup temporary loop devices
718 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
696 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
719 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
697 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
720 fi
698 fi
721
699
722 if [ "$ENABLE_CRYPTFS" = true ] ; then
700 if [ "$ENABLE_CRYPTFS" = true ] ; then
723 # Create dummy ext4 fs
701 # Create dummy ext4 fs
724 mkfs.ext4 "$ROOT_LOOP"
702 mkfs.ext4 "$ROOT_LOOP"
725
703
726 # Setup password keyfile
704 # Setup password keyfile
727 touch .password
705 touch .password
728 chmod 600 .password
706 chmod 600 .password
729 echo -n "${CRYPTFS_PASSWORD}" > .password
707 echo -n "${CRYPTFS_PASSWORD}" > .password
730
708
731 # Initialize encrypted partition
709 # Initialize encrypted partition
732 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
710 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
733
711
734 # Open encrypted partition and setup mapping
712 # Open encrypted partition and setup mapping
735 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
713 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
736
714
737 # Secure delete password keyfile
715 # Secure delete password keyfile
738 shred -zu .password
716 shred -zu .password
739
717
740 # Update temporary loop device
718 # Update temporary loop device
741 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
719 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
742
720
743 # Wipe encrypted partition (encryption cipher is used for randomness)
721 # Wipe encrypted partition (encryption cipher is used for randomness)
744 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
722 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
745 fi
723 fi
746
724
747 # Build filesystems
725 # Build filesystems
748 mkfs.vfat "$FRMW_LOOP"
726 mkfs.vfat "$FRMW_LOOP"
749 mkfs.ext4 "$ROOT_LOOP"
727 mkfs.ext4 "$ROOT_LOOP"
750
728
751 # Mount the temporary loop devices
729 # Mount the temporary loop devices
752 mkdir -p "$BUILDDIR/mount"
730 mkdir -p "$BUILDDIR/mount"
753 mount "$ROOT_LOOP" "$BUILDDIR/mount"
731 mount "$ROOT_LOOP" "$BUILDDIR/mount"
754
732
755 mkdir -p "$BUILDDIR/mount/boot/firmware"
733 mkdir -p "$BUILDDIR/mount/boot/firmware"
756 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
734 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
757
735
758 # Copy all files from the chroot to the loop device mount point directory
736 # Copy all files from the chroot to the loop device mount point directory
759 rsync -a "${R}/" "$BUILDDIR/mount/"
737 rsync -a "${R}/" "$BUILDDIR/mount/"
760
738
761 # Unmount all temporary loop devices and mount points
739 # Unmount all temporary loop devices and mount points
762 cleanup
740 cleanup
763
741
764 # Create block map file(s) of image(s)
742 # Create block map file(s) of image(s)
765 if [ "$ENABLE_SPLITFS" = true ] ; then
743 if [ "$ENABLE_SPLITFS" = true ] ; then
766 # Create block map files for "bmaptool"
744 # Create block map files for "bmaptool"
767 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
745 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
768 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
746 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
769
747
770 # Image was successfully created
748 # Image was successfully created
771 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
749 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
772 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
750 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
773 else
751 else
774 # Create block map file for "bmaptool"
752 # Create block map file for "bmaptool"
775 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
753 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
776
754
777 # Image was successfully created
755 # Image was successfully created
778 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
756 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
779
757
780 # Create qemu qcow2 image
758 # Create qemu qcow2 image
781 if [ "$ENABLE_QEMU" = true ] ; then
759 if [ "$ENABLE_QEMU" = true ] ; then
782 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
760 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
783 QEMU_SIZE=16G
761 QEMU_SIZE=16G
784
762
785 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
763 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
786 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
764 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
787
765
788 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
766 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
789 fi
767 fi
790 fi
768 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant